/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0






/* Copy the first part of user declarations.  */
#line 27 "lscp.y"


#include "lscpparser.h"
#include "lscpserver.h"
#include "lscpevent.h"

// to save us typing work in the rules action definitions
#define LSCPSERVER ((yyparse_param_t*) yyparse_param)->pServer

// clears input buffer
void restart(yyparse_param_t* pparam, int& yychar);
#define RESTART restart((yyparse_param_t*) YYPARSE_PARAM, yychar)

// we provide our own version of yyerror() so we don't have to link against the yacc library
void yyerror(const char* s);

static char buf[1024]; // input buffer to feed the parser with new characters
static int bytes = 0;  // current number of characters in the input buffer
static int ptr   = 0;  // current position in the input buffer

// external reference to the function which actually reads from the socket
extern int GetLSCPCommand( void *buf, int max_size);

// custom scanner function which reads from the socket
int yylex(YYSTYPE* yylval) {
    // check if we have to read new characters
    if (ptr >= bytes) {
        bytes = GetLSCPCommand(buf, 1023);
        ptr   = 0;
        if (bytes < 0) {
            bytes = 0;
            return 0;
        }
    }
    return (int) buf[ptr++];
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 121 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  40
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4496

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  227
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  92
/* YYNRULES -- Number of rules. */
#define YYNRULES  423
/* YYNRULES -- Number of states. */
#define YYNSTATES  1155

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   257

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     225,     2,     2,   226,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,   224,    73,     7,     3,    74,    75,    76,     6,
      77,    78,    79,     9,     5,    10,     8,    80,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    81,    82,
      83,     4,    84,    85,    86,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    87,    88,    89,    90,    91,     2,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    92,    93,    94,    95,     2,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     1,     2
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     6,    10,    11,    13,    15,    17,    19,
      22,    25,    28,    31,    35,    39,    43,    47,    51,    55,
      61,    65,    69,    73,    77,    83,    85,    87,    89,    91,
      93,    95,    97,    99,   101,   103,   105,   107,   109,   111,
     113,   115,   121,   129,   139,   141,   147,   155,   165,   167,
     169,   175,   181,   189,   199,   207,   217,   219,   225,   233,
     239,   245,   251,   259,   269,   277,   287,   291,   295,   301,
     305,   311,   315,   319,   323,   327,   331,   337,   345,   351,
     361,   367,   373,   379,   385,   391,   395,   401,   403,   405,
     407,   409,   411,   413,   415,   417,   423,   431,   435,   437,
     439,   441,   443,   445,   447,   449,   451,   453,   455,   457,
     459,   461,   463,   467,   469,   473,   477,   479,   481,   483,
     485,   487,   490,   494,   499,   504,   506,   509,   511,   513,
     515,   517,   519,   521,   523,   525,   527,   529,   531,   534,
     537,   540,   543,   546,   549,   552,   555,   558,   560,   562,
     564,   566,   568,   570,   572,   574,   576,   578,   580,   582,
     584,   586,   588,   590,   592,   594,   596,   598,   600,   602,
     604,   606,   608,   610,   612,   614,   616,   618,   620,   622,
     624,   626,   628,   630,   632,   634,   636,   638,   640,   642,
     644,   646,   648,   650,   652,   654,   656,   658,   660,   662,
     664,   666,   668,   670,   672,   674,   676,   678,   680,   682,
     684,   686,   688,   690,   692,   694,   696,   698,   700,   702,
     704,   706,   708,   710,   712,   714,   716,   718,   720,   722,
     724,   726,   728,   730,   732,   734,   736,   738,   740,   742,
     744,   746,   748,   750,   752,   754,   756,   758,   760,   762,
     764,   766,   768,   770,   772,   774,   776,   778,   780,   782,
     784,   786,   788,   790,   792,   794,   796,   798,   800,   802,
     804,   806,   808,   810,   812,   814,   816,   818,   820,   822,
     824,   826,   828,   830,   832,   834,   836,   838,   840,   842,
     844,   846,   848,   850,   852,   854,   856,   858,   860,   862,
     864,   866,   868,   870,   872,   874,   876,   878,   880,   882,
     884,   886,   888,   890,   892,   894,   896,   898,   900,   902,
     904,   906,   908,   910,   912,   914,   916,   918,   920,   922,
     924,   926,   928,   930,   932,   934,   936,   938,   940,   942,
     944,   946,   948,   950,   952,   954,   956,   958,   960,   962,
     964,   966,   968,   970,   972,   974,   976,   978,   980,   982,
     984,   986,   988,   990,   992,   994,   996,   998,  1000,  1003,
    1006,  1010,  1014,  1016,  1018,  1020,  1024,  1028,  1035,  1043,
    1048,  1053,  1057,  1067,  1074,  1078,  1088,  1100,  1107,  1115,
    1133,  1164,  1173,  1178,  1190,  1203,  1215,  1226,  1233,  1263,
    1284,  1304,  1334,  1354,  1385,  1406,  1424,  1453,  1481,  1507,
    1526,  1544,  1572,  1590,  1606,  1625,  1641,  1652,  1659,  1665,
    1676,  1682,  1696,  1701
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     228,     0,    -1,   229,   268,    -1,   229,   269,   268,    -1,
      -1,   230,    -1,   231,    -1,     1,    -1,     3,    -1,   230,
       3,    -1,   230,   267,    -1,   230,   263,    -1,   230,   259,
      -1,   270,   267,   283,    -1,   271,   267,   234,    -1,   272,
     267,   236,    -1,   273,   267,   237,    -1,   274,   267,   242,
      -1,   275,   267,   238,    -1,   278,   267,   283,   267,   252,
      -1,   279,   267,   235,    -1,   280,   267,   232,    -1,   281,
     267,   233,    -1,   282,   267,   265,    -1,   315,   267,   283,
     267,   252,    -1,   315,    -1,   318,    -1,   286,    -1,   290,
      -1,   289,    -1,   288,    -1,   287,    -1,   316,    -1,   286,
      -1,   290,    -1,   289,    -1,   288,    -1,   287,    -1,   316,
      -1,   284,    -1,   301,    -1,   307,   267,   287,   267,   259,
      -1,   306,   267,   287,   267,   259,   267,   259,    -1,   306,
     267,   287,   267,   259,   267,   259,   267,   240,    -1,   285,
      -1,   297,   267,   287,   267,   259,    -1,   296,   267,   287,
     267,   259,   267,   259,    -1,   296,   267,   287,   267,   259,
     267,   259,   267,   240,    -1,   294,    -1,   304,    -1,   295,
     267,   287,   267,   263,    -1,   305,   267,   287,   267,   263,
      -1,   308,   267,   287,   267,   263,   267,   263,    -1,   303,
     267,   287,   267,   263,   267,   263,   267,   259,    -1,   299,
     267,   287,   267,   263,   267,   263,    -1,   298,   267,   287,
     267,   263,   267,   263,   267,   259,    -1,   286,    -1,   283,
     267,   287,   267,   252,    -1,   283,   267,   288,   267,   241,
     267,   252,    -1,   283,   267,   289,   267,   252,    -1,   283,
     267,   290,   267,   252,    -1,   292,   267,   287,   267,   254,
      -1,   293,   267,   263,   267,   259,     4,   256,    -1,   298,
     267,   263,   267,   263,   267,   259,     4,   256,    -1,   302,
     267,   263,   267,   259,     4,   256,    -1,   303,   267,   263,
     267,   263,   267,   259,     4,   256,    -1,   283,   267,   239,
      -1,   317,   267,   258,    -1,   295,   267,   259,   267,   240,
      -1,   295,   267,   259,    -1,   305,   267,   259,   267,   240,
      -1,   305,   267,   259,    -1,   295,   267,   263,    -1,   305,
     267,   263,    -1,   291,   267,   243,    -1,   292,   267,   244,
      -1,   295,   267,   252,   267,   245,    -1,   299,   267,   252,
     267,   246,   267,   246,    -1,   300,   267,   252,   267,   247,
      -1,   311,   267,   252,   267,   245,   267,   248,   267,   249,
      -1,   305,   267,   252,   267,   245,    -1,   308,   267,   252,
     267,   248,    -1,   309,   267,   252,   267,   249,    -1,   310,
     267,   252,   267,   250,    -1,   312,   267,   252,   267,   251,
      -1,   259,     4,   256,    -1,   240,   267,   259,     4,   256,
      -1,   313,    -1,   314,    -1,   294,    -1,   304,    -1,   286,
      -1,   284,    -1,   301,    -1,   285,    -1,   255,   267,   253,
     267,   252,    -1,   277,   267,   255,   267,   253,   267,   252,
      -1,   254,   267,   252,    -1,   263,    -1,   263,    -1,   259,
      -1,   263,    -1,   263,    -1,   276,    -1,   259,    -1,   260,
      -1,   263,    -1,   263,    -1,   263,    -1,   259,    -1,   266,
      -1,   257,    -1,   256,     5,   257,    -1,   259,    -1,     6,
     259,     6,    -1,     7,   259,     7,    -1,   263,    -1,   260,
      -1,   263,    -1,   259,    -1,   264,    -1,   259,   264,    -1,
     261,     8,   261,    -1,     9,   261,     8,   261,    -1,    10,
     261,     8,   261,    -1,   262,    -1,   261,   262,    -1,    11,
      -1,    12,    -1,    13,    -1,    14,    -1,    15,    -1,    16,
      -1,    17,    -1,    18,    -1,    19,    -1,    20,    -1,   262,
      -1,    12,   261,    -1,    13,   261,    -1,    14,   261,    -1,
      15,   261,    -1,    16,   261,    -1,    17,   261,    -1,    18,
     261,    -1,    19,   261,    -1,    20,   261,    -1,    21,    -1,
      22,    -1,    23,    -1,    24,    -1,    25,    -1,    26,    -1,
      27,    -1,    28,    -1,    29,    -1,    30,    -1,    31,    -1,
      32,    -1,    33,    -1,    34,    -1,    35,    -1,    36,    -1,
      37,    -1,    38,    -1,    39,    -1,    40,    -1,    41,    -1,
      42,    -1,    43,    -1,    44,    -1,    45,    -1,    46,    -1,
      47,    -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,
      52,    -1,    53,    -1,    54,    -1,    55,    -1,    56,    -1,
      57,    -1,    58,    -1,    59,    -1,    60,    -1,    61,    -1,
      62,    -1,    63,    -1,    64,    -1,    65,    -1,    66,    -1,
      67,    -1,    68,    -1,    69,    -1,    70,    -1,    71,    -1,
      72,    -1,    11,    -1,    12,    -1,    13,    -1,    14,    -1,
      15,    -1,    16,    -1,    17,    -1,    18,    -1,    19,    -1,
      20,    -1,    73,    -1,     3,    -1,    74,    -1,    75,    -1,
      76,    -1,    77,    -1,    78,    -1,    79,    -1,     9,    -1,
      10,    -1,     8,    -1,     5,    -1,    80,    -1,    81,    -1,
      82,    -1,    83,    -1,     4,    -1,    84,    -1,    85,    -1,
      86,    -1,    87,    -1,    88,    -1,    89,    -1,    90,    -1,
      91,    -1,    92,    -1,    93,    -1,    94,    -1,    95,    -1,
      96,    -1,    97,    -1,    98,    -1,    99,    -1,   100,    -1,
     101,    -1,   102,    -1,   103,    -1,   104,    -1,   105,    -1,
     106,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   112,    -1,   113,    -1,   114,    -1,   115,    -1,
     116,    -1,   117,    -1,   118,    -1,   119,    -1,   120,    -1,
     121,    -1,   122,    -1,   123,    -1,   124,    -1,   125,    -1,
     126,    -1,   127,    -1,   128,    -1,   129,    -1,   130,    -1,
     131,    -1,   132,    -1,   133,    -1,   134,    -1,   135,    -1,
     136,    -1,   137,    -1,   138,    -1,   139,    -1,   140,    -1,
     141,    -1,   142,    -1,   143,    -1,   144,    -1,   145,    -1,
     146,    -1,   147,    -1,   148,    -1,   149,    -1,   150,    -1,
     151,    -1,   152,    -1,   153,    -1,   154,    -1,   155,    -1,
     156,    -1,   157,    -1,   158,    -1,   159,    -1,   160,    -1,
     161,    -1,   162,    -1,   163,    -1,   164,    -1,   165,    -1,
     166,    -1,   167,    -1,   168,    -1,   169,    -1,   170,    -1,
     171,    -1,   172,    -1,   173,    -1,   174,    -1,   175,    -1,
     176,    -1,   177,    -1,   178,    -1,   179,    -1,   180,    -1,
     181,    -1,   182,    -1,   183,    -1,   184,    -1,   185,    -1,
     186,    -1,   187,    -1,   188,    -1,   189,    -1,   190,    -1,
     191,    -1,   192,    -1,   193,    -1,   194,    -1,   195,    -1,
     196,    -1,   197,    -1,   198,    -1,   199,    -1,   200,    -1,
     201,    -1,   202,    -1,   203,    -1,   204,    -1,   205,    -1,
     206,    -1,   207,    -1,   208,    -1,   209,    -1,   210,    -1,
     211,    -1,   212,    -1,   213,    -1,   214,    -1,   215,    -1,
     216,    -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,
     221,    -1,   222,    -1,   223,    -1,   267,    -1,   259,    -1,
     265,   267,    -1,   265,   259,    -1,     6,   265,     6,    -1,
       7,   265,     7,    -1,   224,    -1,   225,    -1,   226,    -1,
      21,    24,    24,    -1,    27,    25,    40,    -1,    23,    38,
      25,    21,    40,    25,    -1,    24,    25,    39,    40,    38,
      35,    45,    -1,    32,    29,    39,    40,    -1,    32,    35,
      21,    24,    -1,    21,    32,    32,    -1,    34,    35,    34,
      91,    33,    35,    24,    21,    32,    -1,    38,    25,    33,
      35,    42,    25,    -1,    39,    25,    40,    -1,    39,    41,
      22,    39,    23,    38,    29,    22,    25,    -1,    41,    34,
      39,    41,    22,    39,    23,    38,    29,    22,    25,    -1,
      39,    25,    32,    25,    23,    40,    -1,    23,    28,    21,
      34,    34,    25,    32,    -1,    21,    42,    21,    29,    32,
      21,    22,    32,    25,    91,    25,    34,    27,    29,    34,
      25,    39,    -1,    21,    42,    21,    29,    32,    21,    22,
      32,    25,    91,    21,    41,    24,    29,    35,    91,    35,
      41,    40,    36,    41,    40,    91,    24,    38,    29,    42,
      25,    38,    39,    -1,    23,    28,    21,    34,    34,    25,
      32,    39,    -1,    29,    34,    26,    35,    -1,    22,    41,
      26,    26,    25,    38,    91,    26,    29,    32,    32,    -1,
      39,    40,    38,    25,    21,    33,    91,    23,    35,    41,
      34,    40,    -1,    42,    35,    29,    23,    25,    91,    23,
      35,    41,    34,    40,    -1,    29,    34,    39,    40,    38,
      41,    33,    25,    34,    40,    -1,    25,    34,    27,    29,
      34,    25,    -1,    21,    41,    24,    29,    35,    91,    35,
      41,    40,    36,    41,    40,    91,    24,    25,    42,    29,
      23,    25,    91,    36,    21,    38,    21,    33,    25,    40,
      25,    38,    -1,    21,    41,    24,    29,    35,    91,    35,
      41,    40,    36,    41,    40,    91,    24,    25,    42,    29,
      23,    25,    39,    -1,    21,    41,    24,    29,    35,    91,
      35,    41,    40,    36,    41,    40,    91,    24,    25,    42,
      29,    23,    25,    -1,    21,    41,    24,    29,    35,    91,
      35,    41,    40,    36,    41,    40,    91,    24,    38,    29,
      42,    25,    38,    91,    36,    21,    38,    21,    33,    25,
      40,    25,    38,    -1,    21,    41,    24,    29,    35,    91,
      35,    41,    40,    36,    41,    40,    91,    24,    38,    29,
      42,    25,    38,    -1,    21,    41,    24,    29,    35,    91,
      35,    41,    40,    36,    41,    40,    91,    23,    28,    21,
      34,    34,    25,    32,    91,    36,    21,    38,    21,    33,
      25,    40,    25,    38,    -1,    21,    41,    24,    29,    35,
      91,    35,    41,    40,    36,    41,    40,    91,    23,    28,
      21,    34,    34,    25,    32,    -1,    21,    41,    24,    29,
      35,    91,    35,    41,    40,    36,    41,    40,    91,    40,
      45,    36,    25,    -1,    21,    42,    21,    29,    32,    21,
      22,    32,    25,    91,    33,    29,    24,    29,    91,    29,
      34,    36,    41,    40,    91,    24,    38,    29,    42,    25,
      38,    39,    -1,    33,    29,    24,    29,    91,    29,    34,
      36,    41,    40,    91,    24,    25,    42,    29,    23,    25,
      91,    36,    21,    38,    21,    33,    25,    40,    25,    38,
      -1,    33,    29,    24,    29,    91,    29,    34,    36,    41,
      40,    91,    36,    35,    38,    40,    91,    36,    21,    38,
      21,    33,    25,    40,    25,    38,    -1,    33,    29,    24,
      29,    91,    29,    34,    36,    41,    40,    91,    24,    25,
      42,    29,    23,    25,    39,    -1,    33,    29,    24,    29,
      91,    29,    34,    36,    41,    40,    91,    24,    25,    42,
      29,    23,    25,    -1,    33,    29,    24,    29,    91,    29,
      34,    36,    41,    40,    91,    24,    38,    29,    42,    25,
      38,    91,    36,    21,    38,    21,    33,    25,    40,    25,
      38,    -1,    33,    29,    24,    29,    91,    29,    34,    36,
      41,    40,    91,    24,    38,    29,    42,    25,    38,    -1,
      33,    29,    24,    29,    91,    29,    34,    36,    41,    40,
      91,    36,    35,    38,    40,    -1,    33,    29,    24,    29,
      91,    29,    34,    36,    41,    40,    91,    23,    28,    21,
      34,    34,    25,    32,    -1,    33,    29,    24,    29,    91,
      29,    34,    36,    41,    40,    91,    40,    45,    36,    25,
      -1,    33,    29,    24,    29,    91,    29,    34,    36,    41,
      40,    -1,    42,    35,    32,    41,    33,    25,    -1,    22,
      45,    40,    25,    39,    -1,    36,    25,    38,    23,    25,
      34,    40,    21,    27,    25,    -1,    38,    25,    39,    25,
      40,    -1,    33,    29,    39,    23,    25,    32,    32,    21,
      34,    25,    35,    41,    39,    -1,    25,    23,    28,    35,
      -1,    37,    41,    29,    40,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    82,    82,    83,    86,    87,    88,    89,    92,    93,
      94,    95,    96,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   115,   116,   117,
     118,   119,   120,   123,   124,   125,   126,   127,   128,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   156,   157,   158,   159,   160,   161,   164,   165,
     166,   167,   170,   171,   174,   175,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   189,   190,   193,   194,   197,
     198,   199,   200,   201,   202,   205,   206,   209,   212,   215,
     218,   221,   224,   225,   228,   231,   232,   235,   238,   241,
     244,   247,   248,   251,   252,   253,   254,   255,   261,   262,
     265,   266,   269,   270,   271,   275,   276,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   302,   302,   302,   302,   302,   302,   302,
     302,   302,   302,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   304,
     304,   304,   304,   304,   304,   304,   304,   304,   304,   305,
     305,   305,   305,   305,   305,   305,   305,   305,   305,   305,
     305,   305,   306,   306,   306,   306,   306,   306,   306,   307,
     307,   307,   307,   307,   308,   308,   308,   308,   309,   309,
     309,   310,   310,   310,   311,   311,   311,   312,   312,   312,
     313,   313,   313,   314,   314,   314,   315,   315,   315,   316,
     316,   316,   317,   317,   317,   318,   318,   318,   319,   319,
     319,   320,   320,   320,   321,   321,   321,   322,   322,   322,
     323,   323,   323,   324,   324,   324,   325,   325,   325,   326,
     326,   326,   327,   327,   327,   328,   328,   328,   329,   329,
     329,   330,   330,   330,   331,   331,   331,   332,   332,   332,
     333,   333,   333,   334,   334,   334,   335,   335,   335,   336,
     336,   336,   337,   337,   337,   338,   338,   338,   339,   339,
     339,   340,   340,   340,   341,   341,   341,   342,   342,   342,
     343,   343,   343,   344,   344,   344,   345,   345,   345,   346,
     346,   346,   347,   347,   347,   348,   348,   348,   349,   349,
     349,   350,   350,   350,   351,   351,   354,   355,   356,   357,
     360,   361,   367,   370,   373,   376,   379,   382,   385,   388,
     391,   394,   397,   400,   403,   406,   409,   412,   415,   418,
     421,   424,   427,   430,   433,   436,   439,   442,   445,   448,
     451,   454,   457,   460,   463,   466,   469,   472,   475,   478,
     481,   484,   487,   490,   493,   496,   499,   502,   505,   508,
     511,   514,   517,   520
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'#'", "'='", "','", "'''", "'\"'",
  "'.'", "'+'", "'-'", "'0'", "'1'", "'2'", "'3'", "'4'", "'5'", "'6'",
  "'7'", "'8'", "'9'", "'A'", "'B'", "'C'", "'D'", "'E'", "'F'", "'G'",
  "'H'", "'I'", "'J'", "'K'", "'L'", "'M'", "'N'", "'O'", "'P'", "'Q'",
  "'R'", "'S'", "'T'", "'U'", "'V'", "'W'", "'X'", "'Y'", "'Z'", "'a'",
  "'b'", "'c'", "'d'", "'e'", "'f'", "'g'", "'h'", "'i'", "'j'", "'k'",
  "'l'", "'m'", "'n'", "'o'", "'p'", "'q'", "'r'", "'s'", "'t'", "'u'",
  "'v'", "'w'", "'x'", "'y'", "'z'", "'!'", "'$'", "'%'", "'&'", "'('",
  "')'", "'*'", "'/'", "':'", "';'", "'<'", "'>'", "'?'", "'@'", "'['",
  "'\\\\'", "']'", "'^'", "'_'", "'{'", "'|'", "'}'", "'~'", "'\\200'",
  "'\\201'", "'\\202'", "'\\203'", "'\\204'", "'\\205'", "'\\206'",
  "'\\207'", "'\\210'", "'\\211'", "'\\212'", "'\\213'", "'\\214'",
  "'\\215'", "'\\216'", "'\\217'", "'\\220'", "'\\221'", "'\\222'",
  "'\\223'", "'\\224'", "'\\225'", "'\\226'", "'\\227'", "'\\230'",
  "'\\231'", "'\\232'", "'\\233'", "'\\234'", "'\\235'", "'\\236'",
  "'\\237'", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "' '", "'\\n'", "'\\r'",
  "$accept", "input", "line", "comment", "command", "subscribe_event",
  "unsubscribe_event", "get_instruction", "set_instruction",
  "create_instruction", "destroy_instruction", "load_instruction",
  "set_chan_instruction", "key_val_list", "buffer_size_type",
  "list_instruction", "load_instr_args", "load_engine_args",
  "device_index", "audio_channel_index", "audio_output_type_name",
  "midi_input_port_index", "midi_input_channel_index",
  "midi_input_type_name", "volume_value", "sampler_channel",
  "instrument_index", "engine_name", "filename", "param_val_list",
  "param_val", "boolean", "string", "dotnum", "digits", "digit", "number",
  "char", "text", "stringval", "SP", "LF", "CR", "ADD", "GET", "CREATE",
  "DESTROY", "LIST", "LOAD", "ALL", "NON_MODAL", "REMOVE", "SET",
  "SUBSCRIBE", "UNSUBSCRIBE", "SELECT", "CHANNEL", "AVAILABLE_ENGINES",
  "AVAILABLE_AUDIO_OUTPUT_DRIVERS", "CHANNELS", "INFO", "BUFFER_FILL",
  "STREAM_COUNT", "VOICE_COUNT", "INSTRUMENT", "ENGINE",
  "AUDIO_OUTPUT_DEVICE_PARAMETER", "AUDIO_OUTPUT_DEVICES",
  "AUDIO_OUTPUT_DEVICE", "AUDIO_OUTPUT_DRIVER_PARAMETER",
  "AUDIO_OUTPUT_DRIVER", "AUDIO_OUTPUT_CHANNEL_PARAMETER",
  "AUDIO_OUTPUT_CHANNEL", "AUDIO_OUTPUT_TYPE",
  "AVAILABLE_MIDI_INPUT_DRIVERS", "MIDI_INPUT_DEVICE_PARAMETER",
  "MIDI_INPUT_PORT_PARAMETER", "MIDI_INPUT_DEVICES", "MIDI_INPUT_DEVICE",
  "MIDI_INPUT_DRIVER_PARAMETER", "MIDI_INPUT_DRIVER", "MIDI_INPUT_PORT",
  "MIDI_INPUT_CHANNEL", "MIDI_INPUT_TYPE", "MIDI_INPUT", "VOLUME", "BYTES",
  "PERCENTAGE", "RESET", "MISCELLANEOUS", "ECHO", "QUIT", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,    35,    61,    44,    39,    34,    46,    43,
      45,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    33,    36,    37,    38,    40,    41,    42,
      47,    58,    59,    60,    62,    63,    64,    91,    92,    93,
      94,    95,   123,   124,   125,   126,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,    32,    10,    13
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   227,   228,   228,   229,   229,   229,   229,   230,   230,
     230,   230,   230,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   232,   232,   232,
     232,   232,   232,   233,   233,   233,   233,   233,   233,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   235,   235,   235,   235,   235,   235,   236,   236,
     236,   236,   237,   237,   238,   238,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   240,   240,   241,   241,   242,
     242,   242,   242,   242,   242,   243,   243,   244,   245,   246,
     247,   248,   249,   249,   250,   251,   251,   252,   253,   254,
     255,   256,   256,   257,   257,   257,   257,   257,   258,   258,
     259,   259,   260,   260,   260,   261,   261,   262,   262,   262,
     262,   262,   262,   262,   262,   262,   262,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   264,   264,   264,   264,
     264,   264,   264,   264,   264,   264,   265,   265,   265,   265,
     266,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     3,     0,     1,     1,     1,     1,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     7,     9,     1,     5,     7,     9,     1,     1,
       5,     5,     7,     9,     7,     9,     1,     5,     7,     5,
       5,     5,     7,     9,     7,     9,     3,     3,     5,     3,
       5,     3,     3,     3,     3,     3,     5,     7,     5,     9,
       5,     5,     5,     5,     5,     3,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     7,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     1,     1,     1,
       1,     2,     3,     4,     4,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       3,     3,     1,     1,     1,     3,     3,     6,     7,     4,
       4,     3,     9,     6,     3,     9,    11,     6,     7,    17,
      30,     8,     4,    11,    12,    11,    10,     6,    29,    20,
      19,    29,    19,    30,    20,    17,    28,    27,    25,    18,
      17,    27,    17,    15,    18,    15,    10,     6,     5,    10,
       5,    13,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,   373,   374,     2,     0,     9,   225,   220,   219,   217,
     218,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   209,   211,   212,   213,   214,   215,   216,
     221,   222,   223,   224,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   372,    12,   137,    11,   120,    10,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   375,     0,     0,   376,     0,     0,     0,     0,
       0,     0,   384,     0,     0,     3,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   138,   125,   139,   140,
     141,   142,   143,   144,   145,   146,   210,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   121,     0,    13,
       0,     0,     0,     0,    14,     0,    39,    44,    56,     0,
      48,     0,     0,     0,     0,     0,    40,     0,    49,     0,
       0,     0,     0,     0,     0,    15,     0,     0,    16,     0,
       0,     0,     0,     0,    17,    92,    94,    91,    89,    93,
      90,     0,    18,     0,     0,     0,     0,     0,     0,    20,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    21,    27,    31,    30,    29,    28,    32,    22,    33,
      37,    36,    35,    34,    38,   367,    23,   366,     0,     0,
       0,   379,   380,   423,     0,     0,     0,     0,     0,   126,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   369,   368,     0,     0,     0,
       0,   420,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,    71,
     128,   129,   130,   131,   132,   133,   134,   135,   136,    72,
      73,     0,     0,     0,     0,     0,     0,     0,    74,     0,
     110,     0,    75,     0,   109,    19,   107,     0,     0,     0,
       0,     0,     0,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67,   119,   118,
       0,     0,     0,     0,     0,    24,   377,     0,   383,   387,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   422,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   392,     0,     0,
       0,   378,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     0,     0,    87,    88,    59,    60,    61,    50,
       0,    45,     0,     0,     0,    51,     0,    41,     0,     0,
       0,    68,     0,    70,     0,     0,     0,     0,   370,   371,
       0,     0,   108,     0,    97,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   397,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   385,     0,   388,
       0,     0,   388,     0,     0,     0,    58,    46,     0,    54,
       0,    42,    52,     0,     0,     0,     0,     0,   217,   218,
      85,   111,   113,   117,     0,   125,   116,     0,     0,     0,
       0,     0,    95,     0,     0,     0,     0,     0,     0,    76,
      98,     0,    99,    78,   100,    80,    81,   101,     0,    82,
     102,   103,    83,   104,     0,     0,     0,    84,   105,   106,
      62,     0,    64,     0,     0,     0,     0,     0,     0,     0,
       0,   391,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   417,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   386,     0,     0,
       0,   418,     0,    47,    55,    53,    43,     0,     0,    86,
     114,   115,     0,     0,   112,   122,     0,     0,     0,     0,
      96,     0,     0,     0,     0,    77,   381,     0,    63,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     123,   124,     0,     0,   396,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   382,     0,     0,     0,     0,
      79,   393,     0,     0,   395,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     416,     0,   394,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     421,     0,     0,     0,     0,     0,     0,     0,     0,   419,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     413,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   389,     0,
     410,   412,     0,     0,   410,     0,     0,     0,     0,     0,
       0,     0,     0,   413,   415,     0,     0,     0,     0,     0,
     409,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   400,   402,     0,     0,     0,     0,   400,     0,
       0,     0,     0,     0,   405,     0,   404,   399,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   414,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   404,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   408,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   411,     0,   407,     0,     0,     0,   406,     0,     0,
     401,     0,   398,   403,   390
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    12,    13,    14,    15,   391,   398,   334,   379,   355,
     358,   372,   533,   651,   633,   364,   518,   522,   779,   781,
     783,   786,   789,   792,   797,   525,   661,   523,   519,   760,
     761,   547,   762,   763,   764,   266,   526,   268,   406,   520,
     706,    43,    44,    16,    17,    18,    19,    20,    21,   791,
     521,    22,    23,    24,    25,    26,   329,   336,   337,   338,
     393,   394,   395,   396,   373,   339,   381,   340,   341,   342,
     343,   344,   345,   536,   346,   383,   347,   348,   349,   350,
     351,   352,   539,   540,   541,   542,   634,   635,    27,   397,
     385,    28
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -708
static const short int yypact[] =
{
      30,  -708,  -708,     6,    -1,    31,    49,    -3,    55,    52,
      -2,    76,   132,  -113,  1619,  -708,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,  -708,   143,
     155,   158,   163,   187,   206,   201,   127,    41,   210,   199,
    -708,  -708,  -708,  -708,    14,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,   268,   268,   268,   268,   268,   268,   268,   268,
     268,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  2726,  -708,  -708,  -708,  -708,
     217,   115,     8,     8,   110,    86,   217,   116,    37,    37,
    1841,   217,  -708,   220,   203,  -708,   204,   218,   207,   211,
     223,   224,  -708,   212,   209,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,   268,  -708,   268,   268,
     268,   268,   268,   268,   268,   268,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,   225,  -708,
     104,   226,   228,   229,  -708,   -77,  -708,  -708,  -708,   -77,
    -708,   -77,   -77,   -77,   -77,   -77,  -708,   -77,  -708,   -77,
     -77,   -77,   -77,   216,   230,  -708,   -77,   -77,  -708,   -77,
     -77,   122,   232,   234,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,   231,  -708,   -77,   -77,   -77,   248,   241,   237,  -708,
     -77,   -77,   -77,   -77,   -77,   -77,   249,   258,   262,   253,
     259,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  2726,  1841,  -708,   -77,   255,
     214,  -708,  -708,  -708,   274,   277,   296,   297,   275,  -708,
     300,   294,   302,   303,   298,   309,    36,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,   306,   316,   317,
    2726,  2726,   295,   295,   318,   324,   326,   288,    21,  2726,
     295,   327,   320,   328,    19,   295,   295,   295,   295,  2947,
     329,   330,   314,   319,   325,  2726,  -708,   295,   333,   331,
     334,  -708,   323,   336,   337,   339,   346,   348,   344,   350,
     352,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   353,   354,  1841,  1841,
     268,   268,   268,   268,   268,   268,   268,   268,   268,  -708,
    -708,   355,   351,   357,   347,  1841,  1841,   356,  -708,   -77,
    -708,   -77,  -708,   -77,  2726,  -708,  -708,   359,   361,   360,
     349,   363,   362,  -708,   -77,   -77,   -77,   -77,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,  -708,  2726,  -708,
     338,   364,   342,   369,   375,  -708,  -708,   358,  -708,  -708,
     371,   378,   368,   370,   372,   373,   374,   315,   295,    62,
     295,   295,  2726,   295,  2726,  2726,   295,   295,   295,   295,
    2726,  2726,   295,   376,   321,  2726,  2726,   379,   381,   332,
     380,  1175,  1397,   382,   295,   179,   295,   384,  -708,   340,
     385,   386,   388,   295,   295,   295,   295,   295,   295,   295,
     295,   295,  2726,   295,  2726,   295,   392,  -708,   396,   401,
     399,  -708,   391,   387,   402,   341,   405,   408,   409,   406,
    -708,   393,   411,   -77,  -708,  -708,  -708,  -708,  -708,  -708,
    1841,  2726,   -77,   -77,   -77,  -708,  1841,  2726,   -77,   365,
     410,   -77,  3168,   -77,   366,   412,   417,   389,  -708,  -708,
     367,   -77,  -708,   -77,  -708,   397,   418,   419,   420,   413,
     -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,   -77,  3389,
     -77,  3610,   -77,   414,   421,   407,   398,   425,   422,   423,
     424,   438,   429,  -708,   428,   426,   427,   295,  2726,   295,
     295,   295,  2726,   295,   432,   430,  2726,  2063,   448,   431,
     450,   454,   466,   295,   295,   465,   467,   469,   416,   472,
     295,   295,  2726,   295,   295,   257,  2726,   295,   202,  2063,
    2726,  2063,  2726,   452,   477,   453,   488,  -708,   490,  -708,
     473,   481,   476,   480,   492,   495,  -708,  1841,   -77,  -708,
     -77,  1841,  -708,   478,   484,  3831,  2726,  2726,   268,   268,
     540,  -708,  2726,  -708,    89,    11,  -708,   505,   476,   511,
     523,   514,  -708,   -77,   509,   515,   461,   524,   529,  -708,
    -708,   -77,  -708,  -708,  2726,  -708,  -708,  -708,   525,  -708,
    -708,  -708,  -708,  2726,   -77,   268,   268,  -708,  -708,  -708,
     540,  4052,   540,  4273,   530,   534,   535,   526,   541,   520,
     542,  -708,   528,   531,   546,  2726,  2726,  2726,  2726,   532,
     533,  2063,  2284,  2505,   109,   176,  2063,   268,   536,   543,
     539,   551,   295,   537,   544,   547,   549,  -708,   295,   554,
     295,  2063,  2063,   552,   555,   553,   550,  -708,   556,   499,
     557,  -708,   559,   -77,  2726,  2726,   -77,   558,   560,   540,
    -708,  -708,   268,   268,  -708,   268,   562,   563,   564,   574,
    -708,   566,   565,   567,   570,  -708,  -708,   -77,   540,   540,
     575,   571,   568,   576,   572,   177,   521,   577,   573,   527,
     268,   268,   578,   545,  -708,   579,   580,   548,   582,   583,
     257,   584,   588,   591,   586,   592,   587,   600,   608,   106,
     617,   601,   616,   602,   619,  -708,   604,   126,   609,   606,
    -708,  -708,   610,   607,  -708,   561,   625,   626,   630,     0,
     620,   629,   581,   641,   585,   643,   589,   645,   636,   632,
     590,   635,  -708,   183,   646,   648,   649,   637,   653,   650,
     658,   660,   652,   666,   654,   185,   656,   657,   651,    59,
    -708,   664,    47,   667,   665,   612,   672,   662,   668,  -708,
     680,   683,   691,   693,   692,   698,   695,   685,   638,   700,
     696,   681,   709,   690,   704,   655,   711,   710,   717,   718,
     659,   702,   719,   703,   724,   730,   713,   729,   659,    40,
     732,   720,   721,   722,   733,   723,   726,   725,   735,   734,
     728,   727,   738,   745,   742,   747,   739,   748,   749,   750,
     737,   746,   743,   754,   755,   765,   766,   756,  -708,   759,
     751,   705,   777,   776,  -708,   778,   751,   768,   780,   714,
     779,   770,   774,  -708,  -708,   784,   785,   775,   764,   781,
    -708,   782,   787,   794,   798,   808,   809,   799,   802,   812,
     813,   807,   801,   752,   805,   804,   821,   824,  -708,   801,
     815,   757,   828,   820,  -708,   825,   767,  -708,   823,   819,
     771,   818,   830,   767,   829,   831,   841,  -708,   832,   846,
     833,   847,   851,   849,   854,   855,   845,   857,   844,   788,
     850,   852,   843,   853,   856,  -708,   860,   863,   866,   858,
     867,   868,   873,   870,   878,   869,   862,   859,   864,   865,
     872,   871,   875,   881,   883,   888,   889,  -708,   892,   893,
     894,   882,   886,   885,   887,   884,   891,   890,   906,   907,
     895,  -708,   908,  -708,   910,   898,   899,  -708,   900,   901,
    -708,   902,  -708,  -708,  -708
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -584,  -708,  -708,  -708,  -708,  -562,   102,
    -708,   103,    42,  -708,  -708,  -452,   236,   383,   377,  -707,
     118,  -708,   335,   233,    34,   -10,   -14,   322,  -291,  -708,
     -13,   904,  -708,  -708,  -708,  -708,  -708,  -708,  -708,  -708,
    -708,  -708,  -708,  -708,  -708,  -708,   -48,   671,   677,   -74,
    -258,  -245,  -244,  -243,  -708,   678,  -708,   682,  -255,  -708,
    -708,   669,   498,  -708,   684,  -708,   687,   686,  -253,  -708,
    -708,   500,  -708,  -708,  -708,  -708,  -708,  -708,  -708,   688,
    -708,  -708
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -138
static const short int yytable[] =
{
     267,   269,   653,   270,   271,   272,   273,   274,   275,   276,
     277,   278,   279,   280,   281,   555,  -137,   356,   359,   357,
     360,   400,   800,    37,   802,   947,    33,   515,   516,   353,
      29,     1,    34,     2,   401,   402,   403,    30,   948,    38,
     530,   354,   307,   307,   307,   307,   307,   307,   307,   307,
     307,     3,   531,     4,     5,   517,    31,     6,   386,   386,
     362,   532,     7,  1019,   970,   387,   387,     8,     9,    10,
     388,    11,   983,   291,    32,   389,   389,    36,   390,   390,
    1020,   292,   979,   933,   631,   984,   306,   308,   309,   310,
     311,   312,   313,   314,   315,   980,    35,   827,   632,   981,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
      39,   332,    41,    42,   859,   371,   630,   862,   636,   637,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     929,   361,    40,   362,   878,   879,   330,   376,   331,   328,
     332,   377,   930,   363,   664,   421,   422,   264,   333,   378,
     937,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     289,   785,   938,   444,   422,   794,   290,   282,   481,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     283,   482,   483,   484,   863,   515,   516,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   284,   906,   534,
     367,   537,   907,   285,   392,   399,   961,   962,   974,   975,
     908,   795,   796,   296,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   335,   591,   592,   286,   287,   375,   380,
     288,   853,   293,   408,   856,  -137,  -137,  -137,   294,    41,
     328,   409,   412,   410,   411,   746,   414,   413,   415,   416,
     418,   417,   469,   420,   423,    -4,    -4,   438,   425,   439,
     445,   772,   424,   446,   452,   447,   453,   407,   296,   500,
     501,   502,   503,   504,   505,   506,   507,   508,   788,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   451,
     460,   462,   461,   463,   464,   468,   419,   474,   419,   419,
     419,   419,   419,   419,   419,   419,   296,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   470,   471,   476,   472,
     473,   475,   426,   477,   478,   479,   427,   514,   428,   429,
     430,   431,   432,   480,   433,   387,   434,   435,   436,   437,
     496,   497,   511,   440,   441,   512,   442,   443,   528,   265,
     513,   527,   529,   552,   554,   550,   551,   553,   556,   558,
     448,   449,   450,   559,   616,   618,   557,   454,   455,   456,
     457,   458,   459,   562,   560,   563,   561,   564,   565,   566,
     870,   567,   583,   584,   587,   588,   589,   590,   597,   599,
     600,   593,   601,   466,   619,   467,   598,   602,   620,   617,
     622,   623,   624,   621,   626,   625,   629,   627,   628,   667,
     668,   649,   650,   687,   654,   655,   660,   683,   657,   665,
     669,   684,   685,   656,   686,   688,   691,   689,   509,   510,
     711,   666,   690,   692,   693,   694,   696,   709,   695,   705,
     735,   543,   544,   545,   546,   549,   710,   716,   717,   718,
     737,   738,   733,   734,   719,   739,   704,   708,   712,   740,
     741,   742,   743,   768,   754,   745,   744,   753,   568,   569,
     570,   571,   572,   573,   574,   575,   576,   577,   578,   579,
     580,   581,   582,   767,   769,   585,   586,   770,   715,   736,
     307,   307,   307,   307,   307,   307,   307,   307,   307,   771,
     774,   775,   407,   407,   776,   778,   594,   777,   595,   805,
     596,   807,   808,   810,   809,   811,   812,   813,   814,   819,
     820,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   306,   308,   309,   310,   311,   312,
     313,   314,   315,   804,   806,   826,   828,   829,   830,   831,
     833,   834,   835,   836,   837,   844,   843,   839,   845,   639,
     848,   846,   642,   643,   644,   645,   847,   849,   648,   850,
     851,   852,   857,   868,   858,   869,   866,   871,   466,   466,
     662,   880,   873,   874,   867,   872,   876,   327,   882,   881,
     885,   883,   884,   887,   888,   895,   902,   886,   892,   680,
     889,   682,   896,   893,   894,   897,   899,   901,   898,   903,
     904,   915,   909,   905,   911,   405,   921,   910,   912,   913,
     697,   916,   918,   922,   919,   923,   924,   698,   926,   699,
     700,   701,   925,   702,   927,   703,   914,   928,   931,   917,
     933,   932,   934,   935,   936,   939,   940,   942,   713,   944,
     714,   941,   943,   945,   946,   949,   950,   720,   721,   722,
     723,   724,   725,   726,   727,   728,   952,   730,   954,   732,
     956,   957,   951,   958,   960,   963,   953,   964,   965,   966,
     955,   959,   967,   969,   970,   748,   749,   750,   968,   752,
     972,   978,   982,   766,   971,   977,   973,   765,   976,   986,
     662,   988,   985,   987,   989,   991,   780,   782,   990,   780,
     787,   790,   992,   780,   799,   766,   993,   766,   765,   765,
     995,   765,   994,   996,   997,   998,  1002,   327,  1000,   999,
    1003,  1001,  1004,  1005,   815,   816,  1007,   817,   818,  1008,
    1009,   465,  1013,  1010,  1012,  1014,  1006,  1015,   307,   307,
    1011,  1016,  1018,  1021,   419,  1017,  1024,  1023,  1022,  1030,
     832,  1027,  1025,  1032,  1028,  1026,  1031,  1033,   838,  1029,
    1034,  1035,  1036,  1037,  1039,   498,   499,  1038,  1040,  1044,
    1042,   840,  1041,  1043,   524,   307,   307,   327,  1046,  1045,
    1050,  1047,   824,   825,   548,  1049,  1051,  1048,  1052,  1053,
    1058,  1054,  1055,  1056,  1064,  1057,  1059,   766,  1060,  1061,
    1062,   765,   766,  1063,   419,   419,   765,   307,  1066,  1068,
     327,   327,  1065,  1069,   782,  1067,   787,   766,   766,   824,
     825,   765,   765,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1079,  1081,  1078,  1080,  1082,   327,  1083,  1084,  1085,
     405,   405,   307,   307,  1086,   419,  1092,  1087,  1088,  1089,
    1090,   865,  1091,  1093,   900,  1094,  1096,  1098,  1097,  1095,
     327,  1100,  1101,  1099,  1102,  1103,  1104,  1105,  1106,  1108,
     419,   419,  1107,  1111,  1115,  1110,   790,  1117,  1109,  1113,
    1116,  1112,  1118,  1119,  1120,  1121,   890,   891,  1114,  1122,
    1124,  1125,  1123,  1127,  1126,  1128,  1131,   524,  1130,   640,
     641,  1129,  1132,  1133,  1134,   646,   647,  1135,  1136,  1137,
     652,   652,  1138,  1140,  1142,  1141,   465,   465,  1139,  1143,
    1144,  1145,  1146,  1148,  1147,  1149,  1150,  1151,  1152,  1153,
     875,  1154,   920,   877,   864,   365,   382,   679,   295,   681,
     773,   366,   535,   374,   538,   638,   368,     0,   369,     0,
     370,   798,   327,   327,   384,     0,     0,   404,   327,   327,
       0,     0,   663,     0,   327,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   327,     0,   327,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   747,     0,     0,     0,   751,     0,     0,
       0,   755,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   784,     0,     0,
       0,   793,     0,     0,     0,   801,     0,   803,     0,   327,
       0,     0,     0,   327,     0,     0,     0,   327,     0,     0,
       0,     0,     0,     0,   327,     0,     0,     0,     0,     0,
       0,   822,   823,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   327,     0,     0,     0,
       0,     0,     0,     0,     0,   327,     0,     0,     0,     0,
       0,     0,     0,   327,     0,   327,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   327,   327,     0,     0,     0,     0,
     652,   854,   855,   652,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   327,   327,   316,    46,
      47,   658,     0,    48,    49,    50,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     316,    46,    47,     0,   659,    48,    49,    50,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,    45,    46,    47,     0,     0,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   316,    46,    47,     0,     0,    48,
      49,    50,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   316,    46,    47,   756,
     757,    48,   758,   759,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   316,    46,    47,
     860,     0,    48,    49,    50,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   316,    46,
      47,     0,   861,    48,    49,    50,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   316,
      46,    47,     0,     0,    48,    49,    50,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     316,    46,    47,     0,     0,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   316,   707,    47,     0,     0,    48,    49,    50,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   316,   729,    47,     0,     0,    48,    49,    50,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   316,   731,    47,     0,     0,    48,    49,
      50,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   316,   821,    47,     0,     0,    48,
      49,    50,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   316,   841,    47,     0,     0,
      48,    49,    50,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   316,   842,    47,     0,
       0,    48,    49,    50,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263
};

static const short int yycheck[] =
{
      14,    14,   586,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,   467,     5,   272,   273,   272,
     273,   279,   729,    25,   731,    25,    29,     6,     7,    21,
      24,     1,    35,     3,   279,   279,   279,    38,    38,    41,
      21,    33,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    21,    33,    23,    24,    34,    25,    27,    22,    22,
      23,    42,    32,    23,    24,    29,    29,    37,    38,    39,
      33,    41,    25,    32,    25,    39,    39,    25,    42,    42,
      40,    40,    23,    24,    22,    38,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    36,    41,     8,    36,    40,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      34,    25,   225,   226,   821,    29,   568,     8,   570,   571,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      24,    21,     0,    23,   841,   842,    21,    21,    23,    23,
      25,    25,    36,    33,   596,    41,    42,   224,    33,    33,
      24,   603,   604,   605,   606,   607,   608,   609,   610,   611,
      33,   723,    36,    41,    42,   727,    39,    24,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
      25,   426,   426,   426,     8,     6,     7,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    39,    21,   454,
     274,   454,    25,    40,   278,   279,    23,    24,    23,    24,
      33,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,   271,   515,   516,    39,    21,   276,   277,
      29,   815,    22,   281,   818,   224,   225,   226,    39,   225,
      23,    21,    24,    40,    40,   697,    35,    40,    25,    25,
      41,    39,    38,    28,    28,   225,   226,    41,    29,    29,
      28,   713,    34,    29,    23,    34,    29,   280,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    41,
      41,    29,    34,    40,    35,    40,   306,    22,   308,   309,
     310,   311,   312,   313,   314,   315,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    42,    40,    24,    23,
      23,    21,   335,    21,    21,    27,   339,    39,   341,   342,
     343,   344,   345,    24,   347,    29,   349,   350,   351,   352,
      24,    24,    24,   356,   357,    21,   359,   360,    28,    14,
      24,    24,    24,    39,    29,    26,    26,    38,    25,    25,
     373,   374,   375,    40,    26,    23,    35,   380,   381,   382,
     383,   384,   385,    34,    38,    29,    39,    29,    34,    29,
     832,    29,    29,    29,    29,    34,    29,    40,    29,    29,
      41,    35,    29,   406,    25,   408,    35,    35,    23,    35,
      29,    23,    34,    45,    32,    35,    91,    34,    34,    24,
      24,    35,    91,    22,    35,    34,    34,    25,    38,    35,
      32,    25,    21,    91,    25,    38,    21,    25,   442,   443,
      41,    91,    91,    25,    25,    29,    25,    25,    45,    29,
      33,   455,   456,   457,   458,   459,    29,    29,    29,    29,
      25,    29,    38,    32,    41,    32,    91,    91,    91,    35,
      22,    32,    34,    32,    34,    38,    40,    35,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,    35,    34,   498,   499,    33,    91,    91,
     500,   501,   502,   503,   504,   505,   506,   507,   508,    33,
      35,    34,   515,   516,    35,    33,   519,    91,   521,    32,
     523,    23,    22,    32,    41,    39,    36,    25,    23,    41,
      36,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   500,   501,   502,   503,   504,   505,
     506,   507,   508,    91,    91,     5,    41,    36,    25,    35,
      41,    36,    91,    29,    25,    21,    26,    32,    23,   573,
      40,    35,   576,   577,   578,   579,    25,    25,   582,    41,
      39,    25,    40,    34,    41,    24,    40,    40,   591,   592,
     594,    29,    35,    34,    41,    41,    32,   265,    35,    34,
      91,    41,    36,    34,    36,    21,    25,    40,    36,   613,
      40,   615,    36,    40,    40,    40,    36,    32,    41,    41,
      34,    32,    91,    41,    41,   280,    32,    40,    91,    41,
     633,    41,    40,    35,    41,    34,    40,   640,    41,   642,
     643,   644,    40,   646,    34,   648,    91,    29,    21,    91,
      24,    40,    40,    24,    40,    36,    40,    40,   661,    24,
     663,    41,    91,    27,    24,    35,    27,   670,   671,   672,
     673,   674,   675,   676,   677,   678,    25,   680,    25,   682,
      25,    35,    91,    41,    39,    29,    91,    29,    29,    42,
      91,    91,    29,    25,    24,   699,   700,   701,    38,   703,
      24,    40,    28,   707,    42,    38,    42,   707,    42,    34,
     714,    29,    35,    91,    42,    25,   720,   721,    40,   723,
     724,   725,    29,   727,   728,   729,    25,   731,   728,   729,
      28,   731,    29,    25,    29,    40,    45,   405,    28,    91,
      21,    35,    42,    29,   747,   748,    25,   750,   751,    29,
      23,   406,    23,    25,    42,    42,    91,    23,   758,   759,
      91,    21,    23,    21,   764,    42,    34,    36,    38,    25,
     773,    35,    29,    36,    39,    42,    38,    29,   781,    34,
      25,    29,    25,    34,    25,   440,   441,    29,    28,    25,
      34,   794,    45,    40,   449,   795,   796,   465,    23,    34,
      39,    25,   758,   759,   459,    36,    91,    41,    21,    23,
      21,    23,    34,    23,    40,    91,    36,   821,    34,    25,
      25,   821,   826,    38,   824,   825,   826,   827,    36,    25,
     498,   499,    41,    25,   838,    38,   840,   841,   842,   795,
     796,   841,   842,    25,    25,    36,    34,    25,    25,    32,
      39,    36,    21,    91,    40,    21,   524,    32,    91,    21,
     515,   516,   862,   863,    34,   865,    38,    32,    91,    36,
      41,   827,    91,    33,   877,    36,    25,    21,    36,    38,
     548,    24,    21,    40,    25,    21,    21,    32,    21,    91,
     890,   891,    38,    40,    21,    33,   900,    29,    38,    33,
      24,    38,    25,    25,    21,    25,   862,   863,    38,    21,
      38,    42,    33,    38,    40,    33,    25,   572,    33,   574,
     575,    40,    29,    25,    25,   580,   581,    25,    25,    25,
     585,   586,    40,    38,    40,    38,   591,   592,    42,    38,
      40,    25,    25,    25,    39,    25,    38,    38,    38,    38,
     838,    39,   900,   840,   826,   274,   277,   612,    44,   614,
     714,   274,   454,   275,   454,   572,   274,    -1,   274,    -1,
     274,   728,   640,   641,   277,    -1,    -1,   279,   646,   647,
      -1,    -1,   595,    -1,   652,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   679,    -1,   681,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   698,    -1,    -1,    -1,   702,    -1,    -1,
      -1,   706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   722,    -1,    -1,
      -1,   726,    -1,    -1,    -1,   730,    -1,   732,    -1,   747,
      -1,    -1,    -1,   751,    -1,    -1,    -1,   755,    -1,    -1,
      -1,    -1,    -1,    -1,   762,    -1,    -1,    -1,    -1,    -1,
      -1,   756,   757,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   784,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   793,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   801,    -1,   803,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   822,   823,    -1,    -1,    -1,    -1,
     815,   816,   817,   818,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   854,   855,     3,     4,
       5,     6,    -1,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
       3,     4,     5,    -1,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,     3,     4,     5,    -1,    -1,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,     3,     4,     5,    -1,    -1,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,     3,     4,     5,
       6,    -1,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,     3,     4,
       5,    -1,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,     3,
       4,     5,    -1,    -1,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
       3,     4,     5,    -1,    -1,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,     3,     4,     5,    -1,    -1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,     3,     4,     5,    -1,    -1,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,     3,     4,     5,    -1,    -1,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,     3,     4,     5,    -1,    -1,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,     3,     4,     5,    -1,    -1,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     3,     4,     5,    -1,
      -1,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,     1,     3,    21,    23,    24,    27,    32,    37,    38,
      39,    41,   228,   229,   230,   231,   270,   271,   272,   273,
     274,   275,   278,   279,   280,   281,   282,   315,   318,    24,
      38,    25,    25,    29,    35,    41,    25,    25,    41,    34,
       0,   225,   226,   268,   269,     3,     4,     5,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   259,   262,   263,   264,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,    24,    25,    39,    40,    39,    21,    29,    33,
      39,    32,    40,    22,    39,   268,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   261,   262,   261,   261,
     261,   261,   261,   261,   261,   261,     3,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,   264,    23,   283,
      21,    23,    25,    33,   234,   283,   284,   285,   286,   292,
     294,   295,   296,   297,   298,   299,   301,   303,   304,   305,
     306,   307,   308,    21,    33,   236,   295,   305,   237,   295,
     305,    21,    23,    33,   242,   284,   285,   286,   294,   301,
     304,    29,   238,   291,   292,   283,    21,    25,    33,   235,
     283,   293,   298,   302,   303,   317,    22,    29,    33,    39,
      42,   232,   286,   287,   288,   289,   290,   316,   233,   286,
     287,   288,   289,   290,   316,   259,   265,   267,   283,    21,
      40,    40,    24,    40,    35,    25,    25,    39,    41,   262,
      28,    41,    42,    28,    34,    29,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,    41,    29,
     267,   267,   267,   267,    41,    28,    29,    34,   267,   267,
     267,    41,    23,    29,   267,   267,   267,   267,   267,   267,
      41,    34,    29,    40,    35,   259,   267,   267,    40,    38,
      42,    40,    23,    23,    22,    21,    24,    21,    21,    27,
      24,   287,   288,   289,   290,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   287,   287,    24,    24,   259,   259,
      12,    13,    14,    15,    16,    17,    18,    19,    20,   263,
     263,    24,    21,    24,    39,     6,     7,    34,   243,   255,
     266,   277,   244,   254,   259,   252,   263,    24,    28,    24,
      21,    33,    42,   239,   295,   299,   300,   305,   308,   309,
     310,   311,   312,   263,   263,   263,   263,   258,   259,   263,
      26,    26,    39,    38,    29,   252,    25,    35,    25,    40,
      38,    39,    34,    29,    29,    34,    29,    29,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,    29,    29,   267,   267,    29,    34,    29,
      40,   265,   265,    35,   267,   267,   267,    29,    35,    29,
      41,    29,    35,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,    26,    35,    23,    25,
      23,    45,    29,    23,    34,    35,    32,    34,    34,    91,
     252,    22,    36,   241,   313,   314,   252,   252,   254,   263,
     259,   259,   263,   263,   263,   263,   259,   259,   263,    35,
      91,   240,   259,   240,    35,    34,    91,    38,     6,     7,
      34,   253,   263,   255,   252,    35,    91,    24,    24,    32,
     252,   252,   252,   252,   252,   252,   252,   252,   252,   259,
     263,   259,   263,    25,    25,    21,    25,    22,    38,    25,
      91,    21,    25,    25,    29,    45,    25,   267,   267,   267,
     267,   267,   267,   267,    91,    29,   267,     4,    91,    25,
      29,    41,    91,   267,   267,    91,    29,    29,    29,    41,
     267,   267,   267,   267,   267,   267,   267,   267,   267,     4,
     267,     4,   267,    38,    32,    33,    91,    25,    29,    32,
      35,    22,    32,    34,    40,    38,   252,   259,   263,   263,
     263,   259,   263,    35,    34,   259,     6,     7,     9,    10,
     256,   257,   259,   260,   261,   262,   263,    35,    32,    34,
      33,    33,   252,   253,    35,    34,    35,    91,    33,   245,
     263,   246,   263,   247,   259,   245,   248,   263,    21,   249,
     263,   276,   250,   259,   245,     9,    10,   251,   260,   263,
     256,   259,   256,   259,    91,    32,    91,    23,    22,    41,
      32,    39,    36,    25,    23,   267,   267,   267,   267,    41,
      36,     4,   259,   259,   261,   261,     5,     8,    41,    36,
      25,    35,   267,    41,    36,    91,    29,    25,   267,    32,
     267,     4,     4,    26,    21,    23,    35,    25,    40,    25,
      41,    39,    25,   240,   259,   259,   240,    40,    41,   256,
       6,     7,     8,     8,   257,   261,    40,    41,    34,    24,
     252,    40,    41,    35,    34,   246,    32,   248,   256,   256,
      29,    34,    35,    41,    36,    91,    40,    34,    36,    40,
     261,   261,    36,    40,    40,    21,    36,    40,    41,    36,
     267,    32,    25,    41,    34,    41,    21,    25,    33,    91,
      40,    41,    91,    41,    91,    32,    41,    91,    40,    41,
     249,    32,    35,    34,    40,    40,    41,    34,    29,    24,
      36,    21,    40,    24,    40,    24,    40,    24,    36,    36,
      40,    41,    40,    91,    24,    27,    24,    25,    38,    35,
      27,    91,    25,    91,    25,    91,    25,    35,    41,    91,
      39,    23,    24,    29,    29,    29,    42,    29,    38,    25,
      24,    42,    24,    42,    23,    24,    42,    38,    40,    23,
      36,    40,    28,    25,    38,    35,    34,    91,    29,    42,
      40,    25,    29,    25,    29,    28,    25,    29,    40,    91,
      28,    35,    45,    21,    42,    29,    91,    25,    29,    23,
      25,    91,    42,    23,    42,    23,    21,    42,    23,    23,
      40,    21,    38,    36,    34,    29,    42,    35,    39,    34,
      25,    38,    36,    29,    25,    29,    25,    34,    29,    25,
      28,    45,    34,    40,    25,    34,    23,    25,    41,    36,
      39,    91,    21,    23,    23,    34,    23,    91,    21,    36,
      34,    25,    25,    38,    40,    41,    36,    38,    25,    25,
      25,    25,    36,    34,    25,    25,    32,    39,    91,    36,
      40,    21,    21,    32,    91,    21,    34,    32,    91,    36,
      41,    91,    38,    33,    36,    38,    25,    36,    21,    40,
      24,    21,    25,    21,    21,    32,    21,    38,    91,    38,
      33,    40,    38,    33,    38,    21,    24,    29,    25,    25,
      21,    25,    21,    33,    38,    42,    40,    38,    33,    40,
      33,    25,    29,    25,    25,    25,    25,    25,    40,    42,
      38,    38,    40,    38,    40,    25,    25,    39,    25,    25,
      38,    38,    38,    38,    39
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 86 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 5:
#line 87 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 6:
#line 88 "lscp.y"
    { LSCPSERVER->AnswerClient(yyvsp[0].String); return LSCP_DONE; }
    break;

  case 7:
#line 89 "lscp.y"
    { LSCPSERVER->AnswerClient("Err:0:Unknown command.\r\n"); RESTART; return LSCP_SYNTAX_ERROR; }
    break;

  case 13:
#line 99 "lscp.y"
    { yyval.String = LSCPSERVER->AddChannel();                          }
    break;

  case 14:
#line 100 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 15:
#line 101 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 16:
#line 102 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 17:
#line 103 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 18:
#line 104 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 19:
#line 105 "lscp.y"
    { yyval.String = LSCPSERVER->RemoveChannel(yyvsp[0].Number);                     }
    break;

  case 20:
#line 106 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 21:
#line 107 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 22:
#line 108 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 23:
#line 109 "lscp.y"
    { yyval.String = LSCPSERVER->QueryDatabase(yyvsp[0].String);                     }
    break;

  case 24:
#line 110 "lscp.y"
    { yyval.String = LSCPSERVER->ResetChannel(yyvsp[0].Number);                      }
    break;

  case 25:
#line 111 "lscp.y"
    { yyval.String = LSCPSERVER->ResetSampler();                        }
    break;

  case 26:
#line 112 "lscp.y"
    { LSCPSERVER->AnswerClient("Bye!\r\n"); return LSCP_QUIT; }
    break;

  case 27:
#line 115 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channels);     }
    break;

  case 28:
#line 116 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_voice_count);  }
    break;

  case 29:
#line 117 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_stream_count); }
    break;

  case 30:
#line 118 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_buffer_fill);  }
    break;

  case 31:
#line 119 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_info);         }
    break;

  case 32:
#line 120 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_misc);         }
    break;

  case 33:
#line 123 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channels);     }
    break;

  case 34:
#line 124 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_voice_count);  }
    break;

  case 35:
#line 125 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_stream_count); }
    break;

  case 36:
#line 126 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_buffer_fill);  }
    break;

  case 37:
#line 127 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_info);         }
    break;

  case 38:
#line 128 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_misc);         }
    break;

  case 39:
#line 131 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableEngines();                          }
    break;

  case 40:
#line 132 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableMidiInputDrivers();                 }
    break;

  case 41:
#line 133 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverInfo(yyvsp[0].String);                     }
    break;

  case 42:
#line 134 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverParameterInfo(yyvsp[-2].String, yyvsp[0].String);        }
    break;

  case 43:
#line 135 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverParameterInfo(yyvsp[-4].String, yyvsp[-2].String, yyvsp[0].KeyValList);    }
    break;

  case 44:
#line 136 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableAudioOutputDrivers();               }
    break;

  case 45:
#line 137 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverInfo(yyvsp[0].String);                   }
    break;

  case 46:
#line 138 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverParameterInfo(yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 47:
#line 139 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverParameterInfo(yyvsp[-4].String, yyvsp[-2].String, yyvsp[0].KeyValList);  }
    break;

  case 48:
#line 140 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDeviceCount();                    }
    break;

  case 49:
#line 141 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDeviceCount();                      }
    break;

  case 50:
#line 142 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDeviceInfo(yyvsp[0].Number);                   }
    break;

  case 51:
#line 143 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDeviceInfo(yyvsp[0].Number);                     }
    break;

  case 52:
#line 144 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputPortInfo(yyvsp[-2].Number, yyvsp[0].Number);                   }
    break;

  case 53:
#line 145 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputPortParameterInfo(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].String);      }
    break;

  case 54:
#line 146 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputChannelInfo(yyvsp[-2].Number, yyvsp[0].Number);              }
    break;

  case 55:
#line 147 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputChannelParameterInfo(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].String); }
    break;

  case 56:
#line 148 "lscp.y"
    { yyval.String = LSCPSERVER->GetChannels();                                  }
    break;

  case 57:
#line 149 "lscp.y"
    { yyval.String = LSCPSERVER->GetChannelInfo(yyvsp[0].Number);                             }
    break;

  case 58:
#line 150 "lscp.y"
    { yyval.String = LSCPSERVER->GetBufferFill(yyvsp[-2].FillResponse, yyvsp[0].Number);                          }
    break;

  case 59:
#line 151 "lscp.y"
    { yyval.String = LSCPSERVER->GetStreamCount(yyvsp[0].Number);                             }
    break;

  case 60:
#line 152 "lscp.y"
    { yyval.String = LSCPSERVER->GetVoiceCount(yyvsp[0].Number);                              }
    break;

  case 61:
#line 153 "lscp.y"
    { yyval.String = LSCPSERVER->GetEngineInfo(yyvsp[0].String);                              }
    break;

  case 62:
#line 156 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputDeviceParameter(yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 63:
#line 157 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputChannelParameter(yyvsp[-6].Number, yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String); }
    break;

  case 64:
#line 158 "lscp.y"
    { yyval.String = LSCPSERVER->SetMidiInputDeviceParameter(yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);        }
    break;

  case 65:
#line 159 "lscp.y"
    { yyval.String = LSCPSERVER->SetMidiInputPortParameter(yyvsp[-6].Number, yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 66:
#line 160 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                         }
    break;

  case 67:
#line 161 "lscp.y"
    { yyval.String = LSCPSERVER->SetEcho((yyparse_param_t*) yyparse_param, yyvsp[0].Dotnum);  }
    break;

  case 68:
#line 164 "lscp.y"
    { yyval.String = LSCPSERVER->CreateAudioOutputDevice(yyvsp[-2].String,yyvsp[0].KeyValList); }
    break;

  case 69:
#line 165 "lscp.y"
    { yyval.String = LSCPSERVER->CreateAudioOutputDevice(yyvsp[0].String);    }
    break;

  case 70:
#line 166 "lscp.y"
    { yyval.String = LSCPSERVER->CreateMidiInputDevice(yyvsp[-2].String,yyvsp[0].KeyValList);   }
    break;

  case 71:
#line 167 "lscp.y"
    { yyval.String = LSCPSERVER->CreateMidiInputDevice(yyvsp[0].String);      }
    break;

  case 72:
#line 170 "lscp.y"
    { yyval.String = LSCPSERVER->DestroyAudioOutputDevice(yyvsp[0].Number); }
    break;

  case 73:
#line 171 "lscp.y"
    { yyval.String = LSCPSERVER->DestroyMidiInputDevice(yyvsp[0].Number);   }
    break;

  case 74:
#line 174 "lscp.y"
    { yyval.String = yyvsp[0].String; }
    break;

  case 75:
#line 175 "lscp.y"
    { yyval.String = yyvsp[0].String; }
    break;

  case 76:
#line 178 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputDevice(yyvsp[0].Number, yyvsp[-2].Number);      }
    break;

  case 77:
#line 179 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputChannel(yyvsp[-2].Number, yyvsp[0].Number, yyvsp[-4].Number); }
    break;

  case 78:
#line 180 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputType(yyvsp[0].String, yyvsp[-2].Number);        }
    break;

  case 79:
#line 181 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInput(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].Number, yyvsp[-6].Number);      }
    break;

  case 80:
#line 182 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputDevice(yyvsp[0].Number, yyvsp[-2].Number);        }
    break;

  case 81:
#line 183 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputPort(yyvsp[0].Number, yyvsp[-2].Number);          }
    break;

  case 82:
#line 184 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputChannel(yyvsp[0].Number, yyvsp[-2].Number);       }
    break;

  case 83:
#line 185 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputType(yyvsp[0].String, yyvsp[-2].Number);          }
    break;

  case 84:
#line 186 "lscp.y"
    { yyval.String = LSCPSERVER->SetVolume(yyvsp[0].Dotnum, yyvsp[-2].Number);                 }
    break;

  case 85:
#line 189 "lscp.y"
    { yyval.KeyValList[yyvsp[-2].String] = yyvsp[0].String;          }
    break;

  case 86:
#line 190 "lscp.y"
    { yyval.KeyValList = yyvsp[-4].KeyValList; yyval.KeyValList[yyvsp[-2].String] = yyvsp[0].String; }
    break;

  case 87:
#line 193 "lscp.y"
    { yyval.FillResponse = fill_response_bytes;      }
    break;

  case 88:
#line 194 "lscp.y"
    { yyval.FillResponse = fill_response_percentage; }
    break;

  case 89:
#line 197 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDevices();           }
    break;

  case 90:
#line 198 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDevices();             }
    break;

  case 91:
#line 199 "lscp.y"
    { yyval.String = LSCPSERVER->ListChannels();                    }
    break;

  case 92:
#line 200 "lscp.y"
    { yyval.String = LSCPSERVER->ListAvailableEngines();            }
    break;

  case 93:
#line 201 "lscp.y"
    { yyval.String = LSCPSERVER->ListAvailableMidiInputDrivers();   }
    break;

  case 94:
#line 202 "lscp.y"
    { yyval.String = LSCPSERVER->ListAvailableAudioOutputDrivers(); }
    break;

  case 95:
#line 205 "lscp.y"
    { yyval.String = LSCPSERVER->LoadInstrument(yyvsp[-4].String, yyvsp[-2].Number, yyvsp[0].Number);       }
    break;

  case 96:
#line 206 "lscp.y"
    { yyval.String = LSCPSERVER->LoadInstrument(yyvsp[-4].String, yyvsp[-2].Number, yyvsp[0].Number, true); }
    break;

  case 97:
#line 209 "lscp.y"
    { yyval.String = LSCPSERVER->SetEngineType(yyvsp[-2].String, yyvsp[0].Number); }
    break;

  case 103:
#line 225 "lscp.y"
    { yyval.Number = 16; }
    break;

  case 106:
#line 232 "lscp.y"
    { yyval.Dotnum = yyvsp[0].Number; }
    break;

  case 112:
#line 248 "lscp.y"
    { yyval.String = yyvsp[-2].String + "," + yyvsp[0].String; }
    break;

  case 114:
#line 252 "lscp.y"
    { yyval.String = "\'" + yyvsp[-1].String + "\'"; }
    break;

  case 115:
#line 253 "lscp.y"
    { yyval.String = "\"" + yyvsp[-1].String + "\""; }
    break;

  case 116:
#line 254 "lscp.y"
    { std::stringstream ss; ss << "\'" << yyvsp[0].Number << "\'"; yyval.String = ss.str(); }
    break;

  case 117:
#line 255 "lscp.y"
    { std::stringstream ss; ss << "\'" << yyvsp[0].Dotnum << "\'"; yyval.String = ss.str(); }
    break;

  case 118:
#line 261 "lscp.y"
    { yyval.Dotnum = yyvsp[0].Number; }
    break;

  case 119:
#line 262 "lscp.y"
    { yyval.Dotnum = -1; }
    break;

  case 120:
#line 265 "lscp.y"
    { std::string s; s = yyvsp[0].Char; yyval.String = s; }
    break;

  case 121:
#line 266 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].Char;                  }
    break;

  case 122:
#line 269 "lscp.y"
    { yyval.Dotnum = atof(String(yyvsp[-2].String + "." + yyvsp[0].String).c_str());                         }
    break;

  case 123:
#line 270 "lscp.y"
    { String s = "+"; s += yyvsp[-2].String; s += "."; s += yyvsp[0].String; yyval.Dotnum = atof(s.c_str()); }
    break;

  case 124:
#line 271 "lscp.y"
    { yyval.Dotnum = atof(String("-" + yyvsp[-2].String + "." + yyvsp[0].String).c_str());                   }
    break;

  case 125:
#line 275 "lscp.y"
    { yyval.String = yyvsp[0].Char;      }
    break;

  case 126:
#line 276 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].Char; }
    break;

  case 127:
#line 279 "lscp.y"
    { yyval.Char = '0'; }
    break;

  case 128:
#line 280 "lscp.y"
    { yyval.Char = '1'; }
    break;

  case 129:
#line 281 "lscp.y"
    { yyval.Char = '2'; }
    break;

  case 130:
#line 282 "lscp.y"
    { yyval.Char = '3'; }
    break;

  case 131:
#line 283 "lscp.y"
    { yyval.Char = '4'; }
    break;

  case 132:
#line 284 "lscp.y"
    { yyval.Char = '5'; }
    break;

  case 133:
#line 285 "lscp.y"
    { yyval.Char = '6'; }
    break;

  case 134:
#line 286 "lscp.y"
    { yyval.Char = '7'; }
    break;

  case 135:
#line 287 "lscp.y"
    { yyval.Char = '8'; }
    break;

  case 136:
#line 288 "lscp.y"
    { yyval.Char = '9'; }
    break;

  case 137:
#line 291 "lscp.y"
    { yyval.Number = atoi(String(1, yyvsp[0].Char).c_str());      }
    break;

  case 138:
#line 292 "lscp.y"
    { yyval.Number = atoi(String(String("1") + yyvsp[0].String).c_str()); }
    break;

  case 139:
#line 293 "lscp.y"
    { yyval.Number = atoi(String(String("2") + yyvsp[0].String).c_str()); }
    break;

  case 140:
#line 294 "lscp.y"
    { yyval.Number = atoi(String(String("3") + yyvsp[0].String).c_str()); }
    break;

  case 141:
#line 295 "lscp.y"
    { yyval.Number = atoi(String(String("4") + yyvsp[0].String).c_str()); }
    break;

  case 142:
#line 296 "lscp.y"
    { yyval.Number = atoi(String(String("5") + yyvsp[0].String).c_str()); }
    break;

  case 143:
#line 297 "lscp.y"
    { yyval.Number = atoi(String(String("6") + yyvsp[0].String).c_str()); }
    break;

  case 144:
#line 298 "lscp.y"
    { yyval.Number = atoi(String(String("7") + yyvsp[0].String).c_str()); }
    break;

  case 145:
#line 299 "lscp.y"
    { yyval.Number = atoi(String(String("8") + yyvsp[0].String).c_str()); }
    break;

  case 146:
#line 300 "lscp.y"
    { yyval.Number = atoi(String(String("9") + yyvsp[0].String).c_str()); }
    break;

  case 147:
#line 302 "lscp.y"
    { yyval.Char = 'A'; }
    break;

  case 148:
#line 302 "lscp.y"
    { yyval.Char = 'B'; }
    break;

  case 149:
#line 302 "lscp.y"
    { yyval.Char = 'C'; }
    break;

  case 150:
#line 302 "lscp.y"
    { yyval.Char = 'D'; }
    break;

  case 151:
#line 302 "lscp.y"
    { yyval.Char = 'E'; }
    break;

  case 152:
#line 302 "lscp.y"
    { yyval.Char = 'F'; }
    break;

  case 153:
#line 302 "lscp.y"
    { yyval.Char = 'G'; }
    break;

  case 154:
#line 302 "lscp.y"
    { yyval.Char = 'H'; }
    break;

  case 155:
#line 302 "lscp.y"
    { yyval.Char = 'I'; }
    break;

  case 156:
#line 302 "lscp.y"
    { yyval.Char = 'J'; }
    break;

  case 157:
#line 302 "lscp.y"
    { yyval.Char = 'K'; }
    break;

  case 158:
#line 302 "lscp.y"
    { yyval.Char = 'L'; }
    break;

  case 159:
#line 302 "lscp.y"
    { yyval.Char = 'M'; }
    break;

  case 160:
#line 302 "lscp.y"
    { yyval.Char = 'N'; }
    break;

  case 161:
#line 302 "lscp.y"
    { yyval.Char = 'O'; }
    break;

  case 162:
#line 302 "lscp.y"
    { yyval.Char = 'P'; }
    break;

  case 163:
#line 302 "lscp.y"
    { yyval.Char = 'Q'; }
    break;

  case 164:
#line 302 "lscp.y"
    { yyval.Char = 'R'; }
    break;

  case 165:
#line 302 "lscp.y"
    { yyval.Char = 'S'; }
    break;

  case 166:
#line 302 "lscp.y"
    { yyval.Char = 'T'; }
    break;

  case 167:
#line 302 "lscp.y"
    { yyval.Char = 'U'; }
    break;

  case 168:
#line 302 "lscp.y"
    { yyval.Char = 'V'; }
    break;

  case 169:
#line 302 "lscp.y"
    { yyval.Char = 'W'; }
    break;

  case 170:
#line 302 "lscp.y"
    { yyval.Char = 'X'; }
    break;

  case 171:
#line 302 "lscp.y"
    { yyval.Char = 'Y'; }
    break;

  case 172:
#line 302 "lscp.y"
    { yyval.Char = 'Z'; }
    break;

  case 173:
#line 303 "lscp.y"
    { yyval.Char = 'a'; }
    break;

  case 174:
#line 303 "lscp.y"
    { yyval.Char = 'b'; }
    break;

  case 175:
#line 303 "lscp.y"
    { yyval.Char = 'c'; }
    break;

  case 176:
#line 303 "lscp.y"
    { yyval.Char = 'd'; }
    break;

  case 177:
#line 303 "lscp.y"
    { yyval.Char = 'e'; }
    break;

  case 178:
#line 303 "lscp.y"
    { yyval.Char = 'f'; }
    break;

  case 179:
#line 303 "lscp.y"
    { yyval.Char = 'g'; }
    break;

  case 180:
#line 303 "lscp.y"
    { yyval.Char = 'h'; }
    break;

  case 181:
#line 303 "lscp.y"
    { yyval.Char = 'i'; }
    break;

  case 182:
#line 303 "lscp.y"
    { yyval.Char = 'j'; }
    break;

  case 183:
#line 303 "lscp.y"
    { yyval.Char = 'k'; }
    break;

  case 184:
#line 303 "lscp.y"
    { yyval.Char = 'l'; }
    break;

  case 185:
#line 303 "lscp.y"
    { yyval.Char = 'm'; }
    break;

  case 186:
#line 303 "lscp.y"
    { yyval.Char = 'n'; }
    break;

  case 187:
#line 303 "lscp.y"
    { yyval.Char = 'o'; }
    break;

  case 188:
#line 303 "lscp.y"
    { yyval.Char = 'p'; }
    break;

  case 189:
#line 303 "lscp.y"
    { yyval.Char = 'q'; }
    break;

  case 190:
#line 303 "lscp.y"
    { yyval.Char = 'r'; }
    break;

  case 191:
#line 303 "lscp.y"
    { yyval.Char = 's'; }
    break;

  case 192:
#line 303 "lscp.y"
    { yyval.Char = 't'; }
    break;

  case 193:
#line 303 "lscp.y"
    { yyval.Char = 'u'; }
    break;

  case 194:
#line 303 "lscp.y"
    { yyval.Char = 'v'; }
    break;

  case 195:
#line 303 "lscp.y"
    { yyval.Char = 'w'; }
    break;

  case 196:
#line 303 "lscp.y"
    { yyval.Char = 'x'; }
    break;

  case 197:
#line 303 "lscp.y"
    { yyval.Char = 'y'; }
    break;

  case 198:
#line 303 "lscp.y"
    { yyval.Char = 'z'; }
    break;

  case 199:
#line 304 "lscp.y"
    { yyval.Char = '0'; }
    break;

  case 200:
#line 304 "lscp.y"
    { yyval.Char = '1'; }
    break;

  case 201:
#line 304 "lscp.y"
    { yyval.Char = '2'; }
    break;

  case 202:
#line 304 "lscp.y"
    { yyval.Char = '3'; }
    break;

  case 203:
#line 304 "lscp.y"
    { yyval.Char = '4'; }
    break;

  case 204:
#line 304 "lscp.y"
    { yyval.Char = '5'; }
    break;

  case 205:
#line 304 "lscp.y"
    { yyval.Char = '6'; }
    break;

  case 206:
#line 304 "lscp.y"
    { yyval.Char = '7'; }
    break;

  case 207:
#line 304 "lscp.y"
    { yyval.Char = '8'; }
    break;

  case 208:
#line 304 "lscp.y"
    { yyval.Char = '9'; }
    break;

  case 209:
#line 305 "lscp.y"
    { yyval.Char = '!'; }
    break;

  case 210:
#line 305 "lscp.y"
    { yyval.Char = '#'; }
    break;

  case 211:
#line 305 "lscp.y"
    { yyval.Char = '$'; }
    break;

  case 212:
#line 305 "lscp.y"
    { yyval.Char = '%'; }
    break;

  case 213:
#line 305 "lscp.y"
    { yyval.Char = '&'; }
    break;

  case 214:
#line 305 "lscp.y"
    { yyval.Char = '('; }
    break;

  case 215:
#line 305 "lscp.y"
    { yyval.Char = ')'; }
    break;

  case 216:
#line 305 "lscp.y"
    { yyval.Char = '*'; }
    break;

  case 217:
#line 305 "lscp.y"
    { yyval.Char = '+'; }
    break;

  case 218:
#line 305 "lscp.y"
    { yyval.Char = '-'; }
    break;

  case 219:
#line 305 "lscp.y"
    { yyval.Char = '.'; }
    break;

  case 220:
#line 305 "lscp.y"
    { yyval.Char = ','; }
    break;

  case 221:
#line 305 "lscp.y"
    { yyval.Char = '/'; }
    break;

  case 222:
#line 306 "lscp.y"
    { yyval.Char = ':'; }
    break;

  case 223:
#line 306 "lscp.y"
    { yyval.Char = ';'; }
    break;

  case 224:
#line 306 "lscp.y"
    { yyval.Char = '<'; }
    break;

  case 225:
#line 306 "lscp.y"
    { yyval.Char = '='; }
    break;

  case 226:
#line 306 "lscp.y"
    { yyval.Char = '>'; }
    break;

  case 227:
#line 306 "lscp.y"
    { yyval.Char = '?'; }
    break;

  case 228:
#line 306 "lscp.y"
    { yyval.Char = '@'; }
    break;

  case 229:
#line 307 "lscp.y"
    { yyval.Char = '['; }
    break;

  case 230:
#line 307 "lscp.y"
    { yyval.Char = '\\'; }
    break;

  case 231:
#line 307 "lscp.y"
    { yyval.Char = ']'; }
    break;

  case 232:
#line 307 "lscp.y"
    { yyval.Char = '^'; }
    break;

  case 233:
#line 307 "lscp.y"
    { yyval.Char = '_'; }
    break;

  case 234:
#line 308 "lscp.y"
    { yyval.Char = '{'; }
    break;

  case 235:
#line 308 "lscp.y"
    { yyval.Char = '|'; }
    break;

  case 236:
#line 308 "lscp.y"
    { yyval.Char = '}'; }
    break;

  case 237:
#line 308 "lscp.y"
    { yyval.Char = '~'; }
    break;

  case 238:
#line 309 "lscp.y"
    { yyval.Char = '\200'; }
    break;

  case 239:
#line 309 "lscp.y"
    { yyval.Char = '\201'; }
    break;

  case 240:
#line 309 "lscp.y"
    { yyval.Char = '\202'; }
    break;

  case 241:
#line 310 "lscp.y"
    { yyval.Char = '\203'; }
    break;

  case 242:
#line 310 "lscp.y"
    { yyval.Char = '\204'; }
    break;

  case 243:
#line 310 "lscp.y"
    { yyval.Char = '\205'; }
    break;

  case 244:
#line 311 "lscp.y"
    { yyval.Char = '\206'; }
    break;

  case 245:
#line 311 "lscp.y"
    { yyval.Char = '\207'; }
    break;

  case 246:
#line 311 "lscp.y"
    { yyval.Char = '\210'; }
    break;

  case 247:
#line 312 "lscp.y"
    { yyval.Char = '\211'; }
    break;

  case 248:
#line 312 "lscp.y"
    { yyval.Char = '\212'; }
    break;

  case 249:
#line 312 "lscp.y"
    { yyval.Char = '\213'; }
    break;

  case 250:
#line 313 "lscp.y"
    { yyval.Char = '\214'; }
    break;

  case 251:
#line 313 "lscp.y"
    { yyval.Char = '\215'; }
    break;

  case 252:
#line 313 "lscp.y"
    { yyval.Char = '\216'; }
    break;

  case 253:
#line 314 "lscp.y"
    { yyval.Char = '\217'; }
    break;

  case 254:
#line 314 "lscp.y"
    { yyval.Char = '\220'; }
    break;

  case 255:
#line 314 "lscp.y"
    { yyval.Char = '\221'; }
    break;

  case 256:
#line 315 "lscp.y"
    { yyval.Char = '\222'; }
    break;

  case 257:
#line 315 "lscp.y"
    { yyval.Char = '\223'; }
    break;

  case 258:
#line 315 "lscp.y"
    { yyval.Char = '\224'; }
    break;

  case 259:
#line 316 "lscp.y"
    { yyval.Char = '\225'; }
    break;

  case 260:
#line 316 "lscp.y"
    { yyval.Char = '\226'; }
    break;

  case 261:
#line 316 "lscp.y"
    { yyval.Char = '\227'; }
    break;

  case 262:
#line 317 "lscp.y"
    { yyval.Char = '\230'; }
    break;

  case 263:
#line 317 "lscp.y"
    { yyval.Char = '\231'; }
    break;

  case 264:
#line 317 "lscp.y"
    { yyval.Char = '\232'; }
    break;

  case 265:
#line 318 "lscp.y"
    { yyval.Char = '\233'; }
    break;

  case 266:
#line 318 "lscp.y"
    { yyval.Char = '\234'; }
    break;

  case 267:
#line 318 "lscp.y"
    { yyval.Char = '\235'; }
    break;

  case 268:
#line 319 "lscp.y"
    { yyval.Char = '\236'; }
    break;

  case 269:
#line 319 "lscp.y"
    { yyval.Char = '\237'; }
    break;

  case 270:
#line 319 "lscp.y"
    { yyval.Char = '\240'; }
    break;

  case 271:
#line 320 "lscp.y"
    { yyval.Char = '\241'; }
    break;

  case 272:
#line 320 "lscp.y"
    { yyval.Char = '\242'; }
    break;

  case 273:
#line 320 "lscp.y"
    { yyval.Char = '\243'; }
    break;

  case 274:
#line 321 "lscp.y"
    { yyval.Char = '\244'; }
    break;

  case 275:
#line 321 "lscp.y"
    { yyval.Char = '\245'; }
    break;

  case 276:
#line 321 "lscp.y"
    { yyval.Char = '\246'; }
    break;

  case 277:
#line 322 "lscp.y"
    { yyval.Char = '\247'; }
    break;

  case 278:
#line 322 "lscp.y"
    { yyval.Char = '\250'; }
    break;

  case 279:
#line 322 "lscp.y"
    { yyval.Char = '\251'; }
    break;

  case 280:
#line 323 "lscp.y"
    { yyval.Char = '\252'; }
    break;

  case 281:
#line 323 "lscp.y"
    { yyval.Char = '\253'; }
    break;

  case 282:
#line 323 "lscp.y"
    { yyval.Char = '\254'; }
    break;

  case 283:
#line 324 "lscp.y"
    { yyval.Char = '\255'; }
    break;

  case 284:
#line 324 "lscp.y"
    { yyval.Char = '\256'; }
    break;

  case 285:
#line 324 "lscp.y"
    { yyval.Char = '\257'; }
    break;

  case 286:
#line 325 "lscp.y"
    { yyval.Char = '\260'; }
    break;

  case 287:
#line 325 "lscp.y"
    { yyval.Char = '\261'; }
    break;

  case 288:
#line 325 "lscp.y"
    { yyval.Char = '\262'; }
    break;

  case 289:
#line 326 "lscp.y"
    { yyval.Char = '\263'; }
    break;

  case 290:
#line 326 "lscp.y"
    { yyval.Char = '\264'; }
    break;

  case 291:
#line 326 "lscp.y"
    { yyval.Char = '\265'; }
    break;

  case 292:
#line 327 "lscp.y"
    { yyval.Char = '\266'; }
    break;

  case 293:
#line 327 "lscp.y"
    { yyval.Char = '\267'; }
    break;

  case 294:
#line 327 "lscp.y"
    { yyval.Char = '\270'; }
    break;

  case 295:
#line 328 "lscp.y"
    { yyval.Char = '\271'; }
    break;

  case 296:
#line 328 "lscp.y"
    { yyval.Char = '\272'; }
    break;

  case 297:
#line 328 "lscp.y"
    { yyval.Char = '\273'; }
    break;

  case 298:
#line 329 "lscp.y"
    { yyval.Char = '\274'; }
    break;

  case 299:
#line 329 "lscp.y"
    { yyval.Char = '\275'; }
    break;

  case 300:
#line 329 "lscp.y"
    { yyval.Char = '\276'; }
    break;

  case 301:
#line 330 "lscp.y"
    { yyval.Char = '\277'; }
    break;

  case 302:
#line 330 "lscp.y"
    { yyval.Char = '\300'; }
    break;

  case 303:
#line 330 "lscp.y"
    { yyval.Char = '\301'; }
    break;

  case 304:
#line 331 "lscp.y"
    { yyval.Char = '\302'; }
    break;

  case 305:
#line 331 "lscp.y"
    { yyval.Char = '\303'; }
    break;

  case 306:
#line 331 "lscp.y"
    { yyval.Char = '\304'; }
    break;

  case 307:
#line 332 "lscp.y"
    { yyval.Char = '\305'; }
    break;

  case 308:
#line 332 "lscp.y"
    { yyval.Char = '\306'; }
    break;

  case 309:
#line 332 "lscp.y"
    { yyval.Char = '\307'; }
    break;

  case 310:
#line 333 "lscp.y"
    { yyval.Char = '\310'; }
    break;

  case 311:
#line 333 "lscp.y"
    { yyval.Char = '\311'; }
    break;

  case 312:
#line 333 "lscp.y"
    { yyval.Char = '\312'; }
    break;

  case 313:
#line 334 "lscp.y"
    { yyval.Char = '\313'; }
    break;

  case 314:
#line 334 "lscp.y"
    { yyval.Char = '\314'; }
    break;

  case 315:
#line 334 "lscp.y"
    { yyval.Char = '\315'; }
    break;

  case 316:
#line 335 "lscp.y"
    { yyval.Char = '\316'; }
    break;

  case 317:
#line 335 "lscp.y"
    { yyval.Char = '\317'; }
    break;

  case 318:
#line 335 "lscp.y"
    { yyval.Char = '\320'; }
    break;

  case 319:
#line 336 "lscp.y"
    { yyval.Char = '\321'; }
    break;

  case 320:
#line 336 "lscp.y"
    { yyval.Char = '\322'; }
    break;

  case 321:
#line 336 "lscp.y"
    { yyval.Char = '\323'; }
    break;

  case 322:
#line 337 "lscp.y"
    { yyval.Char = '\324'; }
    break;

  case 323:
#line 337 "lscp.y"
    { yyval.Char = '\325'; }
    break;

  case 324:
#line 337 "lscp.y"
    { yyval.Char = '\326'; }
    break;

  case 325:
#line 338 "lscp.y"
    { yyval.Char = '\327'; }
    break;

  case 326:
#line 338 "lscp.y"
    { yyval.Char = '\330'; }
    break;

  case 327:
#line 338 "lscp.y"
    { yyval.Char = '\331'; }
    break;

  case 328:
#line 339 "lscp.y"
    { yyval.Char = '\332'; }
    break;

  case 329:
#line 339 "lscp.y"
    { yyval.Char = '\333'; }
    break;

  case 330:
#line 339 "lscp.y"
    { yyval.Char = '\334'; }
    break;

  case 331:
#line 340 "lscp.y"
    { yyval.Char = '\335'; }
    break;

  case 332:
#line 340 "lscp.y"
    { yyval.Char = '\336'; }
    break;

  case 333:
#line 340 "lscp.y"
    { yyval.Char = '\337'; }
    break;

  case 334:
#line 341 "lscp.y"
    { yyval.Char = '\340'; }
    break;

  case 335:
#line 341 "lscp.y"
    { yyval.Char = '\341'; }
    break;

  case 336:
#line 341 "lscp.y"
    { yyval.Char = '\342'; }
    break;

  case 337:
#line 342 "lscp.y"
    { yyval.Char = '\343'; }
    break;

  case 338:
#line 342 "lscp.y"
    { yyval.Char = '\344'; }
    break;

  case 339:
#line 342 "lscp.y"
    { yyval.Char = '\345'; }
    break;

  case 340:
#line 343 "lscp.y"
    { yyval.Char = '\346'; }
    break;

  case 341:
#line 343 "lscp.y"
    { yyval.Char = '\347'; }
    break;

  case 342:
#line 343 "lscp.y"
    { yyval.Char = '\350'; }
    break;

  case 343:
#line 344 "lscp.y"
    { yyval.Char = '\351'; }
    break;

  case 344:
#line 344 "lscp.y"
    { yyval.Char = '\352'; }
    break;

  case 345:
#line 344 "lscp.y"
    { yyval.Char = '\353'; }
    break;

  case 346:
#line 345 "lscp.y"
    { yyval.Char = '\354'; }
    break;

  case 347:
#line 345 "lscp.y"
    { yyval.Char = '\355'; }
    break;

  case 348:
#line 345 "lscp.y"
    { yyval.Char = '\356'; }
    break;

  case 349:
#line 346 "lscp.y"
    { yyval.Char = '\357'; }
    break;

  case 350:
#line 346 "lscp.y"
    { yyval.Char = '\360'; }
    break;

  case 351:
#line 346 "lscp.y"
    { yyval.Char = '\361'; }
    break;

  case 352:
#line 347 "lscp.y"
    { yyval.Char = '\362'; }
    break;

  case 353:
#line 347 "lscp.y"
    { yyval.Char = '\363'; }
    break;

  case 354:
#line 347 "lscp.y"
    { yyval.Char = '\364'; }
    break;

  case 355:
#line 348 "lscp.y"
    { yyval.Char = '\365'; }
    break;

  case 356:
#line 348 "lscp.y"
    { yyval.Char = '\366'; }
    break;

  case 357:
#line 348 "lscp.y"
    { yyval.Char = '\367'; }
    break;

  case 358:
#line 349 "lscp.y"
    { yyval.Char = '\370'; }
    break;

  case 359:
#line 349 "lscp.y"
    { yyval.Char = '\371'; }
    break;

  case 360:
#line 349 "lscp.y"
    { yyval.Char = '\372'; }
    break;

  case 361:
#line 350 "lscp.y"
    { yyval.Char = '\373'; }
    break;

  case 362:
#line 350 "lscp.y"
    { yyval.Char = '\374'; }
    break;

  case 363:
#line 350 "lscp.y"
    { yyval.Char = '\375'; }
    break;

  case 364:
#line 351 "lscp.y"
    { yyval.Char = '\376'; }
    break;

  case 365:
#line 351 "lscp.y"
    { yyval.Char = '\377'; }
    break;

  case 366:
#line 354 "lscp.y"
    { yyval.String = " ";      }
    break;

  case 368:
#line 356 "lscp.y"
    { yyval.String = yyvsp[-1].String + " "; }
    break;

  case 369:
#line 357 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].String;  }
    break;

  case 370:
#line 360 "lscp.y"
    { yyval.String = yyvsp[-1].String; }
    break;

  case 371:
#line 361 "lscp.y"
    { yyval.String = yyvsp[-1].String; }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 4403 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 523 "lscp.y"


/**
 * Will be called when an error occured (usually syntax error).
 */
void yyerror(const char* s) {
    dmsg(2,("LSCPParser: %s\n", s));
}

/**
 * Clears input buffer.
 */
void restart(yyparse_param_t* pparam, int& yychar) {
    bytes = 0;
    ptr   = 0;
}


